// commdll.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "commdll.h"
#include "btcomm.h"

CwclAPI* pAPI = NULL;

int _API_ dllInitialize()
{
	if (pAPI)
		return WCL_E_API_LOADED;

	pAPI = new CwclAPI();
	int iRes = pAPI->Load();
	if (iRes != WCL_E_SUCCESS)
	{
		delete pAPI;
		pAPI = NULL;
	}

	return iRes;
}

int _API_ dllFinalize()
{
	if (!pAPI)
		return WCL_E_API_NOT_LOADED;

	pAPI->Unload();
	delete pAPI;
	pAPI = NULL;

	return WCL_E_SUCCESS;
}

void _API_ dllFreeMem(LPVOID pMem)
{
	if (!pMem)
		return;

	LocalFree((HLOCAL)pMem);
}

int _API_ dllDiscovery(LPBT_DEVICES* ppDevices)
{
	if (!pAPI)
		return WCL_E_API_NOT_LOADED;

	CBtDiscovery* pDiscovery = new CBtDiscovery();
	int iRes = pDiscovery->Discovery(ppDevices);
	delete pDiscovery;

	return iRes;
}

int _API_ dllCreateClient(BT_MAC szMac, BT_CLIENT_HANDLE* pHandle)
{
	*pHandle = new CBtClient(szMac);
	return WCL_E_SUCCESS;
}

int _API_ dllDestroyClient(BT_CLIENT_HANDLE Handle)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;
	
	delete (CBtClient*)Handle;

	return WCL_E_SUCCESS;
}
int _API_ dllConnect(BT_CLIENT_HANDLE Handle)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;

	return ((CBtClient*)Handle)->Connect();

}

int _API_ dllDisconnect(BT_CLIENT_HANDLE Handle)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;

	return ((CBtClient*)Handle)->Disconnect();
}

int _API_ dllWrite(BT_CLIENT_HANDLE Handle, LPVOID pData, DWORD dwSize)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;

	return ((CBtClient*)Handle)->Write(pData, dwSize);
}

int _API_ dllRead(BT_CLIENT_HANDLE Handle, LPVOID pData, LPDWORD pdwSize)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;

	return ((CBtClient*)Handle)->Read(pData, pdwSize);
}

int _API_ dllGetDataSize(BT_CLIENT_HANDLE Handle, LPDWORD pdwSize)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;

	return ((CBtClient*)Handle)->GetDataSize(pdwSize);
}

int _API_ dllIsConnected(BT_CLIENT_HANDLE Handle, bool* pConnected)
{
	if (!Handle)
		return WCL_E_INVALID_ARGUMENT;

	*pConnected = ((CBtClient*)Handle)->IsConnected();

	return WCL_E_SUCCESS;
}