#pragma once

#ifdef COMMDLL_EXPORTS
	#define _API_ __declspec(dllexport) __stdcall
#else
	#define _API_ __declspec(dllimport) __stdcall
#endif

#define BT_MAX_MAC_SIZE		19
#define BT_MAX_NAME_SIZE	64

typedef TCHAR	BT_MAC[BT_MAX_MAC_SIZE + 1];
typedef BT_MAC	*PBT_MAC, *LPBT_MAC;
typedef LPVOID	BT_CLIENT_HANDLE;

typedef struct _BT_DEVICES_
{
	INT_PTR	cCount;
	BT_MAC	Mac[1];
} BT_DEVICES, *PBT_DEVICES, *LPBT_DEVICES;

extern "C"
{
	int _API_ dllInitialize();
	int _API_ dllFinalize();

	void _API_ dllFreeMem(LPVOID pMem);

	int _API_ dllDiscovery(LPBT_DEVICES* ppDevices);

	int _API_ dllCreateClient(BT_MAC szMac, BT_CLIENT_HANDLE* pHandle);
	int _API_ dllDestroyClient(BT_CLIENT_HANDLE Handle);
	int _API_ dllConnect(BT_CLIENT_HANDLE Handle);
	int _API_ dllDisconnect(BT_CLIENT_HANDLE Handle);
	int _API_ dllWrite(BT_CLIENT_HANDLE Handle, LPVOID pData, DWORD dwSize);
	int _API_ dllRead(BT_CLIENT_HANDLE Handle, LPVOID pData, LPDWORD pdwSize);
	int _API_ dllGetDataSize(BT_CLIENT_HANDLE Handle, LPDWORD pdwSize);
	int _API_ dllIsConnected(BT_CLIENT_HANDLE Handle, bool* pConnected);
}